#!/usr/bin/env python

import numpy as np, os, sys, json
from keras.models import load_model

"""
模型预测
Updated on 2021/06/23 by pan xia
"""

def vote1(tmpPredProbs, threshold):
    predProbs = np.mean(tmpPredProbs, axis=0)
    predLabels = np.array(predProbs > threshold, dtype='int')
    return predLabels, predProbs


def vote2(tmpPredProbs, threshold):
    tmp = np.array(np.array(tmpPredProbs) > threshold, dtype='int')

    predProbs = [np.sum(tmp[:, i]) * 1.0 / len(tmp) for i in range(len(tmp[0]))]

    predLabels = np.array(np.array(predProbs) > 0.5, dtype='int')
    return predLabels, predProbs


def myPredict(model, x_test):
    threshold = 0.2
    tmpPredProbs = []
    for m in model:
        tmpPredProbs.append(m.predict(np.array(x_test))[0])
    predLabels, predProbs = vote1(tmpPredProbs, threshold)  # vote2
    return predLabels, predProbs


def load_mymodel(model_directory, file):
    model = load_model(os.path.join(model_directory, file), compile=False)
    return model
